/*!
 * jQuery ClassyEdit
 * http://www.class.pm/projects/jquery/classyedit
 *
 * Written by Marius Stanciu - Sergiu <marius@picozu.com>
 * Licensed under the GPL Version 3 license.
 * Version 1.1.0
 *
 */

(function($) {
    triggerclick = function() {
        thiselement = window.getSelection().focusNode.parentNode;
        $(thiselement).trigger("click");
    };
    $.fn.ClassyEdit = function(c) {
        var e, h, i = ["start"], f = $(this);
        "undefined" == typeof $.fn.ClassyEdit.counter ? $.fn.ClassyEdit.counter = 1 : $.fn.ClassyEdit.counter++;
        for (var b = $.fn.ClassyEdit.counter, c = $.extend({
            animation: !0,
            buttons: "bold italic underline insertUnorderedList href html".split(" ")
        }, c), g = '<div class="classyedit" classyeditor="' + b + '"><div class="toolbar">', j = 0; j < c.buttons.length; j++)
            firstline = 0 == j ? " first" : "", g = g + '<div class="button' + firstline + '"><a href="#" command="' + c.buttons[j] + '"></a></div>';
        g = g + '</div><div class="editor" contenteditable="true">' + f.val() + '</div><textarea class="html_editor">' + f.val() + "</textarea></div>";
        f.hide();
        f.after(g);
        e = $("[classyeditor='" + b + "'] [contenteditable]");
        !1 == c.animation && ($("[classyeditor='" + b + "'] .toolbar").show(), $("[classyeditor='" + b + "'] .editor").css("marginTop", "-6px"));
        $("[classyeditor='" + b + "'] .editor").focus(function() {
            if (c.animation == true) {
                clearTimeout(h);
                $(this).parent().find(".toolbar").slideDown("fast");
                $(this).css("marginTop", "-6px");
            }
        });
        $("[classyeditor='" + b + "'] .editor").focusout(function() {
            if (c.animation == true) {
                var a = jQuery(this);
                h = setTimeout(function() {
                    a.parent().find(".toolbar").slideUp("fast");
                    a.css("marginTop", "0px");
                }, 100);
            }
        });
        $("[classyeditor='" + b + "'] .html_editor").focus(function() {
            $(this).parent().find(".toolbar").slideDown("fast");
        });
        $("[classyeditor='" + b + "'] [contenteditable]").focus(function() {
            e = this;
        });
        $("[classyeditor='" + b + "'] [contenteditable]").keyup(function() {
            triggerclick();
        });
        $("[classyeditor='" + b + "'] [contenteditable]").click(function() {
            cleantoolbar(b);
        });
        $("[classyeditor='" + b + "'] [contenteditable]").focusout(function() {
            f.val($(this).html());
            $("[classyeditor='" + b + "'] .html_editor").val($(this).html());
            $("[classyeditor='" + b + "'] .html_editor").css("height", $(this).height());
        });
        $("[classyeditor='" + b + "'] .button a").click(function(a) {
            a.preventDefault();
        });
        cleantoolbar = function(b) {
            $("[classyeditor='" + b + "'] [command]").each(function() {
                jQuery.inArray($(this).attr("command"), i) > 0 ? $(this).parent().addClass("on") : $(this).parent().removeClass("on")
            });
            i = ["start"];
        };
        buttonstate = function(b, d, c) {
            if (d == "on") {
                $("[classyeditor='" + c + "'] [command='" + b + "']").parent().addClass("on");
                b != "html" && i.push(b);
            } else if (d == "off")
                $("[classyeditor='" + c + "'] [command='" + b + "']").parent().removeClass("on");
            else {
                return $("[classyeditor='" + c + "'] [command='" + b + "']").parent().hasClass("on");
            }
        };
        $("[classyeditor='" + b + "'] [contenteditable]").delegate("b", "click", function() {
            buttonstate("bold", "on", b);
        });
        $("[classyeditor='" + b + "'] [contenteditable]").delegate("u", "click", function() {
            buttonstate("underline", "on", b);
        });
        $("[classyeditor='" + b + "'] [contenteditable]").delegate("i", "click", function() {
            buttonstate("italic", "on", b);
        });
        $("[classyeditor='" + b + "'] [contenteditable]").delegate("ul", "click", function() {
            buttonstate("insertUnorderedList", "on", b);
        });
        $("[classyeditor='" + b + "'] [contenteditable]").delegate("a", "click", function() {
            buttonstate("href", "on", b);
        });
        $("[classyeditor='" + b + "'] [command]").click(function() {
            var c = true, d = $(this).attr("command");
            if (e == null) {
                alert("Click an editable area first");
                return false;
            }
            buttonstate(d, "", b) ? buttonstate(d, "off", b) : buttonstate(d, "on", b);
            if (d == "html") {
                clearTimeout(h);
                if (buttonstate(d, "", b) == true) {
                    $("[classyeditor='" + b + "'] [contenteditable]").hide();
                    $("[classyeditor='" + b + "'] .html_editor").show();
                }
                else {
                    $("[classyeditor='" + b + "'] [contenteditable]").html($("[classyeditor='" + b + "'] .html_editor").val());
                    f.val($("[classyeditor='" + b + "'] .html_editor").val());
                    $("[classyeditor='" + b + "'] [contenteditable]").show();
                    $("[classyeditor='" + b + "'] .html_editor").hide();
                }
                return true;
            }
            if (d == "bold" || d == "italic" || d == "underline" || d == "href")
                try {
                    document.execCommand("styleWithCSS", 0, false);
                } catch (g) {
                    try {
                        document.execCommand("useCSS", 0, true);
                    } catch (i) {
                        try {
                            document.execCommand("styleWithCSS", false, false);
                        } catch (j) {
                        }
                    }
                }
            if (d == "href") {
                c = prompt("Type a url:", "http://");
                if (!c)
                    return false;
                d = "createLink";
            }
            clearTimeout(h);
            document.execCommand(d, false, c);
        });
    }
})(jQuery);